;*******************************************************************
;                           bmul.asm
;                   8x8 Software Multiplier
;*******************************************************************
;
;   The 16 bit result is stored in 2 bytes
;
; Before calling the subroutine "bmul", the multiplier should
; be loaded in location "B7", and the multiplicand in
; "B6".  The 16 bit result is stored in location D1.
; Contents of B5 changes.
;
;       Performance :   ROM        :  14 locations
;                       cycles     :  71
;                       RAM        :  
;
;  This routine is optimized for code efficiency ( looped code )
;*******************************************************************
;

#include "processr.inc"
#include "registrs.inc"

          CODE

bmul
          GLOBAL    bmul

          clrf      D1
          clrf      D1+1
          movlw     8
          movwf     B5
          movf      B6,         W
          bcf       STATUS,     C      ; Clear the carry bit in the status Reg.
loop      rrf       B7,         F
          btfsc     STATUS,     C
          addwf     D1,         F
          rrf       D1,         F
          rrf       D1+1,       F
          decfsz    B5,         F
          goto      loop
          return

          END
