;*******************************************************************
;                           dadd.asm
;                 Add to 16 bit unsigned integers.
;*******************************************************************
;
;   The 16 bit result is stored in D0.
;
; Before calling the subroutine "dadd", the integers should
; be loaded in location D0 and D1.
; Contents of W and B5 changes.
; Bit C set if overflov.
; Performance :   ROM        :  12 locations
;                 RAM        :  
;                 cycles     :  22 (include call)
;*******************************************************************
;

#include "processr.inc"
#include "registrs.inc"

            CODE
            GLOBAL      dadd

dadd        clrw                                ;+
            movwf       B5                      ;
            movf        D1+1,       W           ;
            addwf       D0+1,       F           ;
            btfss       STATUS,     C           ; Calculate
            goto        dadd5                   ; lb of result.
            incf        D0,         F           ;
            btfss       STATUS,     Z           ;
            goto        dadd4                   ;
            incf        B5                      ;-
dadd4       goto        dadd3                   ;	
dadd3       movf        D1,         W           ;+ 
            addwf       D0,         F           ;
            btfss       STATUS,     C           ;
            goto        dadd1                   ; Calculate
            goto        dadd2                   ; hb of result.
dadd2       return                              ;
dadd1       rrf         B5,         F           ;
            return                              ;-
dadd5       nop                                 ;
            goto        dadd4                   ;

            end

