;*******************************************************************
;                           dadd.inc
;             Add two 16 bit unsigned integers macro.
;*******************************************************************
;
;   The 16 bit result is stored in D0.
;   Performance :   ROM     :   9 locations
;                   RAM     :   
;                   cycles  :   max 10+12
;
;  Syntax: DFDFAdd _D1, _D2        : Add two 16 bit regs
;          DFDLAdd _D1, _LH, _LL   : Add 16 bit const to reg
;          DFSLAdd _D1, _LL        : Add  8 bit const to reg
;          D0DFAdd _D2             : Add 16 bit reg to D0
;          D0DLAdd _LH, _LL        : Add 16 bit const to D0
;          D0SLAdd _LL             : Add  8 bit const to D0
;*******************************************************************
;

IFNDEF    __REGISTERS
#include  "registrs.inc"
ENDIF
          EXTERN   dadd

DFDFAdd   macro     _D1,      _D2
          movf      _D1,      W
          movwf     D0
          movf      _D1+1,    W
          movwf     D0+1
          movf      _D2,      W
          movwf     D1
          movf      _D2+1,    W
          movwf     D1+1
          call      dadd
          endm

DFDLAdd   macro     _D1,      _LH,      _LL
          movf      _D1,      W
          movwf     D0
          movf      _D1+1,    W
          movwf     D0+1
          movlw     _LH
          movwf     D1
          movlw     _LL
          movwf     D1+1
          call      dadd
          endm

DFSLAdd   macro     _D1,      _LL
          movf      _D1,      W
          movwf     D0
          movf      _D1+1,    W
          movwf     D0+1
          clrf      D1
          movlw     _LL
          movwf     D1+1
          call      dadd
          endm

D0DFAdd   macro     _D2
          movf      _D2,      W
          movwf     D1
          movf      _D2+1,    W
          movwf     D1+1
          call      dadd
          endm

D0DLAdd   macro     _LH,      _LL
          movlw     _LH
          movwf     D1
          movlw     _LL
          movwf     D1+1
          call      dadd
          endm

D0SLAdd   macro     _LL
          clrf      D1
          movlw     _LL
          movwf     D1+1
          call      dadd
          endm

