;*******************************************************************
;                           dsub.asm
;              Subtract 16 bit unsigned integers.
;*******************************************************************
;
; The 16 bit result is stored in D0.
; Before calling the subroutine "dsub", the integers should
; be loaded in location D0 and D1.
; Bit C clear if negative.
; Performance :   ROM     :  14 locations
;                 RAM     :   
;                 cycles  :  15 (include call)
;*******************************************************************
;

#include "processr.inc"
#include "registrs.inc"

          CODE
          GLOBAL    dsub

dsub      movf      D1+1,     W      ; Mov low byte to W.        ; 1
          subwf     D0+1,     F      ; Sub W from lb of result.  ; 1
          btfsc     STATUS,   C      ;+If do not negative        ; 1(2)
          goto      HiByte2          ;-goto HiByte               ; 2
          movf      D0,       F      ;+                          ; 1
          btfss     STATUS,   Z      ; If Hi byte of D0          ; 1(2)
          goto      lb1              ; is null (0x00)            ; 2
          bcf       STATUS,   C      ;                           ; 1
          nop                        ;+delay
          goto      ret1             ;-3 cycles
ret1      return                     ;-                          ; 2
lb1       decf      D0,       F      ; Dec D0                    ; 1
HiByte1   movf      D1,       W      ;+Calculate                 ; 1
          subwf     D0,       F      ;-high byte                 ; 1
          return                                                 ; 2
HiByte2   goto      HiByte3          ;+delay
HiByte3   goto      HiByte1          ;-4 cycles.
          end

