;************************************************************************
;    Filename:           RUOZ.asm                                       *
;    Date begin project: 05.10.1999                                     *
;    Date released:      19.03.2001                                     *
;    File Version:  5.21                                                *
;                                                                       *
;    Author:        Zakamaldin A.                                       *
;    Company:       private                                             *
;************************************************************************
; ver 1.01     clcerr   - *
;           calcangl.                                                *
; ver 1.02    dodelay.                 *
;             RA0, RA1.                    *
;               .                     *
;           ,      .   *
; ver 1.10      interrupt latency.     *
;               .                    *
;            RB0,    0 . .          *
;              1           *
;           .                                         *
;            ,             *
;           ,  -    - *
;          .                                                       *
; ver 1.20      8.                 *
;               .                    *
;             ,          *
;            .   .   *
;               . ,    *
;             .                                         *
; ver 1.21      . .  *
; ver 1.30      10.                *
;               .   *
;            ,   Tbl6 (. .  ~1100), *
;                .    *
;             -     ,       *
;              RB0.                     *
;                .           *
;              .               *
; ver 1.31     .            *
;                      *
;            .                                      *
; ver 1.32     . .     *
;            .           *
;           .          *
;                 2 -   *
;            .                                       *
; ver 2.00      10   HS.    *
;            chktimer.                            *
;               9,   *
;               2 .                     *
;              15+11 .                    *
;           . delay235, corrdelay, dodelay  mainloop.   *
;           calcdelay            *
;           . . .                               *
; ver 2.01  ,         *
;          . .                                              *
; ver 2.02     Delta_Press,     *
;            .                                       *
; ver 2.10        *
;           3           *
;           .                                           *
;                    *
;                .     *
;               .           *
; ver 2.20     Fosc/32,   *
;             10 MHz.    .*
;              15+12 .   *
;             RB5. Reg_Delay   2.      *
;                 *
;               -. *
; ver 2.30     15+11 .  - *
;              286-575 /     *
;               .    *
;           1   .    -*
;          .    91-, 91, 92/93, 95.        *
; ver 2.40       .*
;                  .  *
; ver 2.50     .   *
;              .  - *
;                  *
;             -.         *
; ver 2.60     15+10 .     *
;           .    "       *
;          ",  256        *
;          .   .    76, 91-, *
;          92, 92+.                                                     *
; ver 3.00       - *
;            .      .     *
;                 -76.          *
; ver 3.10     .     *
;            "Check engine" -  ,  -*
;            -    .      *
;           -92.                                                       *
; ver 3.20       .    *
;             WDT        *
;           .     readadc  chkpsensor. *
;                .    *
;              A-76.                                   *
; ver 3.21    reset.                                 *
; ver 3.30       .        *
; ver 3.31        A-76.               *
; ver 3.32        -92-, -92,-95.*
;              -95.                         *
; ver 3.40        -92-, -92,-95.*
;              -95.   -*
;             16 .   -  25 .*
; ver 3.41        A-76, -92-.       *
; ver 3.41z       .  A-92-  *
;             A-76+.                                       *
; ver 3.50         -*
;            .       *
;               ,     *
;             ,   25 .                  *
; ver 3.60       .              *
; ver 3.70      checkadc.  *
;                -76.                             *
; ver 4.00      checkadc.    *
;               .      *
;                ,   *
;                 *
;           .    getpressure.                  *
; ver 4.10           *
;            .     checkadc    *
;           getpressure.                                                *
; ver 4.11     Low2Hi_Del       *
;            .                                            *
; ver 4.20       .     *
; ver 4.30       -76  -76+.   *
;                 4 .  - *
;               4   32    -*
;           .                                                         *
; ver 4.31       255 .          *
; ver 5.00            *
;             (  v 2.60).    *
;              1600 / .  - *
;             calcangl.      .    *
;                ,    *
;              3500 /.                               *
; ver 5.10    .   . -*
;           .      .     *
;              .       *
;             .                                        *
; ver 5.11         -92  95.*
; ver 5.20       -76  -76+.  - *
;             mainloop.                                         *
; ver 5.21   .   -76, -76+, -91       *
;           -93,95.      -91.          *
;************************************************************************
;    Files required: processr.inc,                                      *
;                    registrs.inc, registrs.obj,                        *
;                    bmul.inc, dadd.inc, dsub.inc                       *
;                    16c715.lkr, 16c715.lib                             *
;                                                                       *
;************************************************************************
;    Notes: RA0/AN0 -                             *
;           RA1-RA4 -   out                           *
;           RB0     -    -                   *
;           RB1     -                                  *
;           RB2,RB3 -   (00-76, 10-76+, 01-92, 11-95)            *
;           RB4     -                   *
;           RB5     -                         *
;           RB6,RB7 -   out                           *
;                                                                       *
;      n*(16-)*(256/90)*256   *
;   -              n*(13-)*(256/90)*256   *
;     _______________________^^^        ^^^^^^^         *
;   .  _______________________________||        |||||||         *
;     .   _____________________|||||||         *
;************************************************************************
            IFDEF       __16C715
#include "proce715.inc"
            ENDIF
#include "registrs.inc"
#include ".\math\bmul.inc"
#include ".\math\dadd.inc"
#include ".\math\dsub.inc"
            RADIX       hex

;  --------------------------------------------------------
            IFDEF       __16C715
            __CONFIG    _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _MPEEN_ON & _HS_OSC
            ENDIF

F_TOverflow EQU         0             ;  .        <-
F_Comutator EQU         1             ;  . .   |
F_ReadyDly  EQU         2             ;  .         |  RUOZFlags.
F_AbortDly  EQU         3             ;   .      |
F_HiRotat   EQU         4             ;  . .   |
F_HiDelay   EQU         5             ;   .       |
F_Hi2Low    EQU         6             ;     hi2low. |
F_Low2Hi    EQU         7             ;     low2hi.<-
F_PSensErr  EQU         0             ;   . <-
F_PSensNChk EQU         1             ;  .  .  |
F_PSensHChk EQU         2             ;       |  RUOZFlag2.
F_PSensLChk EQU         3             ;        |
F_PSensBlOn EQU         4             ;  ( ).       |
F_PSensCnst EQU         5             ; .  . . <-
PSChk_Mask  EQU         B'00001100'   ;    .
Max_Timer   EQU         4             ;   .
Rnd_Timer   EQU         7             ;   .
Reg_Delay   EQU         0x01          ; -    .
Dly_Boo_Cnt EQU         D'255'        ;  -   .
Dly_Boo_Tmr EQU         D'183'        ; .    .
Min_Timer1  EQU         D'045'        ; . .  1 (3250 / ).
Min_Timer2  EQU         D'047'        ; . .  2 (3150 / ).
Hi_RotDel1  EQU         0x06          ;+ 
Hi_RotDel2  EQU         0x1E          ;-. .  2.
ADC_LimEnd  EQU         D'208'        ; . . ,    . .
ADC_LimCnst EQU         D'128'        ;   .   .
PSn_MinPres EQU         D'035'        ; .   .,   .
PSn_MaxPres EQU         D'220'        ; .   .,   .
P_CorrectH  EQU         0x0B          ;+  4  - 
P_CorrectL  EQU         0x60          ;-  16+13   25.
Boo_CorrH   EQU         0x11          ;+    6 .
Boo_CorrL   EQU         0x11          ;-
D_CorrectH  EQU         0x04          ;   hi2low.
D_CorrectL  EQU         0x01          ;   low2hi.
H_Align     EQU         D'046'        ; .  Hi.
L_Align     EQU         D'130'        ; .  Lo. 
Int_Config  EQU         B'10010000'   ;   INTCON;
;                         ^^^^_________  .  RB0/INT,
;                         |||__________  .  TMR0,
;                         ||___________  .  ADC,
;                         |____________  GIE.
Opt_CfgHig  EQU         B'01011111'   ;  OPTION Low->High.
Opt_CfgLow  EQU         B'00011111'   ;  OPTION High->Low;
;                         ^^^  ^^^_____  1:128,
;                         |||__________ TMR0    CLKOUT,
;                         ||___________ .   RB0/INT,
;                         |____________  pull-up.
RA_Config   EQU         B'00000011'   ;  RA0,1  in, RA2-4  out.
RB_Config   EQU         B'00011101'   ;  RB0,RB2,RB3,RB4 - input,
                                      ;          RB1,RB5-RB7 - output.


AD0_Config  EQU         B'10000001'   ;  ADCON0;
;                         ^^ ^^  ^_____ A/D  ,
;                         || ||________   RA0/AN0,  
;                         ||___________ . A/D - Fosc/32.
AD1_Config  EQU         B'00000010'   ; RA0,RA1 - . ,
                                      ; RA2,RA3 - , Vref=Vdd.
PCON_MASK   EQU         B'00000111'   ;   PCON.
OCH_Mask    EQU         B'00001100'   ;   .
Tbl_Start   EQU         RAM_Start+0   ;  .  .
Tbl_Size    EQU         D'045'+ D'011';  .  .

;---------------------------------------------------------------------
INT_VAR     UDATA       RAM_Start     ;   .

Tbl1        RES         5             ;+
Tbl2        RES         5             ;
Tbl3        RES         5             ;
Tbl4        RES         5             ;   
Tbl5        RES         5             ;  .
Tbl6        RES         5             ;
Tbl7        RES         5             ;
Tbl8        RES         5             ;
Tbl9        RES         5             ;-
LoPressADC  RES         1             ;+
MdPressADC  RES         1             ;   - .
HiPressADC  RES         1             ;-
LoPressHi   RES         1             ;+ . 
LoPressLo   RES         1             ;-(13-)*256/90*256.
DeltaPrLo   RES         1             ; Delta   Low.
MdPressHi   RES         1             ;+ . 
MdPressLo   RES         1             ;-(13-)*256/90*256.
DeltaPrMd   RES         1             ; Delta   Mid.
HiPressHi   RES         1             ;+ . 
HiPressLo   RES         1             ;-(13-)*256/90*256.
w_tmp       RES         1             ;    W.
status_tmp  RES         1             ;    STATUS.
HiTimer     RES         1             ; .   . .
Timer       RES         1             ;   .
LoTimer     RES         1             ; .   . .
TimerMin    RES         1             ; .   .
CurrTmrHi   RES         1             ;+ 
CurrTmrLo   RES         1             ;-.
HiDelay     RES         1             ;+
MdDelay     RES         1             ; 24     .
LoDelay     RES         1             ;-
TotalAnglHi RES         1             ;+ .
TotalAnglLo RES         1             ;-
PressAnglHi RES         1             ;+ .
PressAnglLo Res         1             ;-
RUOZFlags   RES         1             ;  .
RUOZFlag2   RES         1             ;   2 (  ).
CurrADC     RES         1             ;   .
DelayCorr   RES         2             ;  .
RegDelay    RES         1             ;    .
DlyBoostCnt RES         1             ;    . 
BlCountHi   RES         1             ;+   
BlCountLo   RES         1             ;-  "Check Engine".

;   POR, WDT, MCLR ---------------------------------------
RESET_VEC   CODE        0x000                   ;   .
            clrf        INTCON                  ;   .
            goto        reset                   ;   .


;   RB0/INT ----------------------------------------------
INT_VEC     CODE        0x004                   ;  .
            movwf       w_tmp                   ;  W<-       <-
            movf        STATUS,     W           ;+                          |
            movwf       status_tmp              ;-STATUS.                            |
            clrwdt                              ;  .                     |
            bsf         STATUS,     RP0         ;  1.                            |
            btfsc       OPTION_REG, INTEDG      ;   .        |
            goto        low2hi                  ;  .                         |
hi2low      bcf         STATUS,     RP0         ;  .  0.
            call        chktimer                ;  .
            movf        HiTimer,    W           ;+
            movwf       CurrTmrHi               ;  
            movf        Timer,      W           ;   CurrTmr.
            movwf       CurrTmrLo               ;-
            movf        TMR0,       W           ;  .  .
            movwf       LoTimer                 ;
            clrw                                ;+
            movwf       TMR0                    ;  
            bcf         INTCON,     T0IF        ; .
            movwf       Timer                   ; 
            movwf       HiTimer                 ;-
            movf        RegDelay,   W           ;+   ?
            btfsc       STATUS,     Z           ;-
            goto        hi2low1                 ;   .
            decf        RegDelay                ;+  , 
            goto        low2hiout               ;-   .
hi2low1     bcf         RUOZFlags,  F_HiRotat   ; .   .
            movf        CurrTmrHi,  W           ;+  .
            btfss       STATUS,     Z           ; , 
            goto        hi2low2                 ;-CurrTmrHi   0.
            movf        TimerMin,   W           ;+ 
            subwf       CurrTmrLo,  W           ; . 
            btfss       STATUS,     C           ;-.
            bsf         RUOZFlags,  F_HiRotat   ; .  !
hi2low2     call        calcdelay               ;   Delay.
            btfss       RUOZFlags,  F_ReadyDly  ;+ 
            goto        low2hiout               ;- .
            clrf        DelayCorr               ;+
            movlw       D_CorrectH              ;  .
            movwf       DelayCorr+1             ;-
            call        corrdelay               ;  .
            btfsc       RUOZFlags,  F_AbortDly  ;+ 
            goto        hi2low3                 ;- .
            call        dodelayh2l              ;  .
            btfsc       RUOZFlags,  F_AbortDly  ;+   
            goto        urgntreg                ;- .               |
            call        hialign                 ;  .             |
            btfsc       PORTB,      RB0         ;+        |
            goto        urgntreg                ;- .               |
hi2low3     btfsc       RUOZFlags,  F_Comutator ;    .|
            bsf         PORTB,      RB1         ; 1   <-      <--
hi2lowout   bsf         RUOZFlags,  F_Hi2Low    ;    hi2low.
            bsf         STATUS,     RP0         ;+
            movlw       Opt_CfgHig              ;  OPTION  
            movwf       OPTION_REG              ;    RB0/INT.
            bcf         STATUS,     RP0         ;-
            goto        intout                  ;  .
low2hi      bcf         STATUS,     RP0         ;  0.
            call        chktimer                ;  .
            clrf        DelayCorr               ;+
            movlw       D_CorrectL              ;    .
            movwf       DelayCorr+1             ;-
            call        corrdelay               ;  .
            btfsc       RUOZFlags,  F_AbortDly  ;+ 
            goto        low2hi1                 ;- .
            call        dodelayl2h              ;  .
            btfsc       RUOZFlags,  F_AbortDly  ;+        |
            goto        urgnth2l                ;- .               |
            call        loalign                 ;  .             |
            btfss       PORTB,      RB0         ;+        |
            goto        urgnth2l                ;- .               |
low2hi1     bcf         PORTB,      RB1         ; 0   <-      <--
low2hiout   bsf         RUOZFlags,  F_Low2Hi    ;    low2hi.
            bsf         STATUS,     RP0         ;+
            movlw       Opt_CfgLow              ;  OPTION 
            movwf       OPTION_REG              ;    RB0/INT.
            bcf         STATUS,     RP0         ;-
intout      call        chktimer                ;  .
            bcf         RUOZFlags,  F_AbortDly  ;    .
            bcf         INTCON, INTF            ;   RB0/INT.
            movf        status_tmp, W           ;+
            movwf       STATUS                  ;-STATUS.
            swapf       w_tmp,      F           ;+
            swapf       w_tmp,      W           ;-W.
            retfie
urgntreg    bsf         PORTB,      RB1         ;+1  .    <-
            call        chktimer                ;  .| 
            call        del1ms5                 ;                  | .
            bcf         PORTB,      RB1         ; 0  .    <-
            goto        low2hiout               ;-   .
urgnth2l    bcf         PORTB,      RB1         ; 0  .
            clrwdt                              ;  .
            clrw                                ;+
            movwf       TMR0                    ;  
            bcf         INTCON,     T0IF        ; .
            movwf       Timer                   ; 
            movwf       HiTimer                 ;-
urgnth2l1   btfsc       PORTB,      RB0         ;+ 
            goto        urgntreg                ;- RB0/INT.
            call        chktimer                ;  .
            goto        urgnth2l1               ;  .


MAIN        CODE        0x068

;     -----------------------------------
ai_tbl      addwf       PCL                     ;   .
a_76        EQU         0x00
ai_tbl0     DT          D'055', 0x0D, 0x5E, 0x00, 0x00;+
            DT          D'065', 0x0F, 0x38, 0x2F, 0x6C; 
            DT          D'077', 0x12, 0x59, 0x42, 0x99; 
            DT          D'090', 0x15, 0x90, 0x3F, 0x7B;  
            DT          D'107', 0x19, 0x84, 0x3B, 0x76;  
            DT          D'130', 0x1D, 0xFB, 0x31, 0xC2;  -76.
            DT          D'165', 0x22, 0xD8, 0x23, 0x98; 
            DT          D'255', 0x28, 0x64, 0x0F, 0xD0;
            DT          D'255', 0x2D, 0x83, 0x0A, 0x2F;-

            DT          D'021', D'059', D'134'                         ;+
            DT          0x23, 0x9E, 0x0A, 0x22, 0x22, 0x50, 0x0A, 0xB2 ;-

a_76p       EQU         a_76  + Tbl_Size
            DT          D'055', 0x0D, 0x5E, 0x00, 0x00;+
            DT          D'065', 0x0F, 0x38, 0x2F, 0x6C; 
            DT          D'077', 0x12, 0x59, 0x42, 0x99; 
            DT          D'090', 0x15, 0x90, 0x3F, 0x7B;  
            DT          D'107', 0x19, 0x84, 0x3B, 0x76;  
            DT          D'130', 0x1D, 0xFB, 0x31, 0xC2;  -76+.
            DT          D'165', 0x22, 0xD8, 0x23, 0x98; 
            DT          D'255', 0x28, 0x64, 0x0F, 0xD0; 
            DT          D'255', 0x2D, 0x83, 0x0A, 0x2F;-

            DT          D'021', D'059', D'134'                         ;+
            DT          0x22, 0x94, 0x03, 0x22, 0x22, 0x50, 0x0A, 0xB2 ;-

a_91        EQU         a_76p  + Tbl_Size
            DT          D'055', 0x05, 0x3C, 0x00, 0x00;+
            DT          D'065', 0x07, 0xD2, 0x42, 0x63; 
            DT          D'077', 0x0B, 0x61, 0x4B, 0xAE; 
            DT          D'090', 0x0E, 0xEF, 0x46, 0x39;  
            DT          D'107', 0x13, 0x50, 0x41, 0xE0;  
            DT          D'130', 0x18, 0x10, 0x34, 0xED;  -92.
            DT          D'165', 0x1D, 0xB9, 0x29, 0x6C; 
            DT          D'255', 0x25, 0xE3, 0x17, 0x46; 
            DT          D'255', 0x2D, 0x83, 0x0F, 0x29;-

            DT          D'021', D'056', D'130'                         ;+
            DT          0x22, 0x68, 0x02, 0x22, 0x22, 0x5E, 0x06, 0xF6 ;-

a_95        EQU         a_91  + Tbl_Size
            DT          D'055', 0x02, 0x47, 0x00, 0x00;+
            DT          D'065', 0x05, 0x1F, 0x48, 0xF4; 
            DT          D'077', 0x08, 0xD1, 0x4E, 0xB5; 
            DT          D'090', 0x0C, 0x84, 0x49, 0x08;  
            DT          D'107', 0x11, 0x11, 0x44, 0x71;  
            DT          D'130', 0x15, 0xE7, 0x35, 0xE1;  -95;
            DT          D'165', 0x1B, 0xE0, 0x2B, 0xB6; 
            DT          D'255', 0x24, 0xFA, 0x19, 0xF3; 
            DT          D'255', 0x2D, 0x83, 0x10, 0xF9;-
;                         ^       ^     ^     ^_____^__ delta,
;                         |       |_____|______________ Y0,
;                         |____________________________ N0.
            DT          D'021', D'054', D'142'                         ;+
;                         ^       ^       ^____________ HiPressADC     ;
;                         |       |____________________ MdPressADC     ; 
;                         |____________________________ LoPressADC     ;
                                                                       ;
            DT          0x22, 0x43, 0x01, 0x22, 0x22, 0x5B, 0x02, 0xDA ;-
;                         ^     ^     ^     ^     ^     ^     ^____ ^_ max vacuum
;                         |     |     |     |     |     |_____________ delta mid
;                         |     |     |     |_____|___________________ mid vacuum
;                         |     |     |_______________________________ delta low
;                         |_____|_____________________________________ low vacuum


;     1,5 . ----
;         
;   - .  D0  B2.
del1ms5     clrf        D0                      ;+
            clrf        B2                      ;  
            movlw       0x0F                    ; .
            movwf       D0+1                    ;-
            bsf         RUOZFlags,  F_HiDelay   ;   .
            call        dodelayl2h              ;  .
            return


;    -----------------------------------------------------
chkfuel     movf        PORTB,      W           ;+
            andlw       OCH_Mask                ;
            btfsc       STATUS,     Z           ; 
            goto        getai76                 ; 
            xorlw       OCH_Mask                ; .
            btfsc       STATUS,     Z           ;  .
            goto        getai95                 ;
            movwf       B7                      ;
            btfsc       B7,         RB2         ;
            goto        getai91                 ;-
getai76p    movlw       a_76p                   ;+
            goto        chkf0                   ;
getai76     movlw       a_76                    ; 
            goto        chkf0                   ; 
getai91     movlw       a_91                    ; .
            goto        chkf0                   ;
getai95     movlw       a_95                    ;-
chkf0       movwf       B7                      ;+ <----------------------
            movlw       Tbl_Start               ;                        |
            movwf       FSR                     ;                        |
            movlw       Tbl_Size                ;                        |
            movwf       B6                      ;             
chkf1       movlw       low ai_tbl0             ;              RAM.
            addwf       B7,         W           ;
            btfsc       STATUS,     C           ;
            goto        chkf2                   ;
            clrw                                ; . goto    255.
            goto        chkf3                   ;
chkf2       movlw       0x01                    ; . goto   255.
chkf3       addlw       high ai_tbl             ;
            movwf       PCLATH                  ; . . . goto
            movf        B7,         W           ;
            call        ai_tbl                  ;
            movwf       INDF                    ;
            incf        B7                      ;
            incf        FSR                     ;
            btfsc       INTCON,     T0IF        ;                |
            call        chktimer0               ; .               |
            decfsz      B6                      ;                        |
            goto        chkf1                   ;- <----------------------
            return

;    .   ADC_LimEnd,   -----------
;       . ,   .
islorotmode movf        CurrTmrHi,  F           ;  ..
            btfss       STATUS,     Z           ;+ CurrTmrHi |= 0,
            goto        islorotmod1             ;-   .
            movlw       ADC_LimEnd              ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo ,  ADC_LimEnd,
            btfsc       STATUS,     C           ;    .
            goto        islorotmod1             ;-
            bcf         STATUS,     C           ;+
            return                              ;- .
islorotmod1 bsf         STATUS,     C           ;+
            return                              ;- .

 
;    -----------------------------------------
reset       clrf        TMR0                    ;  .
            bsf         STATUS,     RP0         ;   1.
            movlw       RA_Config               ;+
            movwf       TRISA                   ;- A.
            movlw       AD1_Config              ;+
            movwf       ADCON1                  ;-   Vref.
            bcf         PIE1,       ADIE        ;  .  ADC.
            movlw       RB_Config               ;+
            movwf       TRISB                   ;- B.
            clrwdt                              ;  .
            movlw       Opt_CfgLow              ;+ OPTION
            movwf       OPTION_REG              ;-    RB0/INT.
            movlw       PCON_MASK               ;+ 
            iorwf       PCON,       F           ;-.
            bcf         STATUS,     RP0         ;   0.
            clrf        PORTA                   ;+ 
            clrf        PORTB                   ;-   B.
            movlw       AD0_Config              ;+
            movwf       ADCON0                  ;  .
            clrf        CurrADC                 ;-
            clrf        RUOZFlags               ;+
            clrf        HiTimer                 ; 
            clrf        Timer                   ;  .
            clrf        LoTimer                 ;- 
            clrf        RUOZFlag2               ;   .
            clrf        BlCountHi               ;+ 
            clrf        BlCountLo               ;-.
            bsf         RUOZFlag2,  F_PSensNChk ;   .
            bsf         RUOZFlag2,  F_PSensCnst ;   .
            call        chkfuel                 ;   .
            movf        MdPressHi,  W           ;+
            movwf       PressAnglHi             ;  
            movf        MdPressLo,  W           ;   .
            movwf       PressAnglLo             ;-
            movlw       Min_Timer1              ;+ .  
            movwf       TimerMin                ;-Min_Timer1.
            movlw       Reg_Delay               ;+  
            movwf       RegDelay                ;- .
            movlw       Dly_Boo_Cnt             ;+  
            movwf       DlyBoostCnt             ;-  .
            movlw       Int_Config              ;+
            movwf       INTCON                  ;- .
            bsf         ADCON0,     GO          ;  AD .
reset1      btfss       PIR1,       ADIF        ;+  AD?
            goto        reset1                  ;  .
            movf        ADRES,      W           ;+ .
            btfsc       STATUS,     Z           ;+ 0, 
            bsf         RUOZFlag2,  F_PSensErr  ;-  .
            movwf       CurrADC                 ;-  .
            bsf         PORTB,      RB5         ;   .


;   ---------------------------------------------------
mainloop    btfsc       RUOZFlags,  F_Hi2Low    ;+  
            goto        mlph2l                  ;- hi2low.
            btfsc       RUOZFlags,  F_Low2Hi    ;+  
            goto        mlpl2h                  ;- hi2low.
mlp0        btfss       PORTB,      RB4         ;           <+
            goto        mlp1                    ; , | 
            bsf         RUOZFlags,  F_Comutator ;+. | 
            goto        mlp2                    ;-           | .
mlp1        bcf         RUOZFlags,  F_Comutator ; .<+
mlp2        call        chktimer                ;  .
            call        psdiagout               ;  - .  .
            goto        mainloop
mlph2l      call        chktimer                ;  .
            call        readadc                 ;   .
            bcf         RUOZFlags,  F_Low2Hi    ;+ .
            bcf         RUOZFlags,  F_Hi2Low    ;-
            goto        mainloop
mlpl2h      call        chktimer                ;  .
            call        chkfuel                 ;   .
            call        chktimer                ;  .
            call        getpressure             ;    .           
            bcf         RUOZFlags,  F_Low2Hi    ;+ .
            bcf         RUOZFlags,  F_Hi2Low    ;-
            goto        mainloop


;   ---------------------------------------------
;  DelayCorr   ,   
;    dodelay.   - 61 .
corrdelay   movf        HiDelay,    W           ;+
            movwf       B0                      ;  . 
            movf        MdDelay,    W           ;  D0.
            movwf       B1                      ;-
            D0DFSub     DelayCorr               ;  .
            btfss       STATUS,     C           ;+ ,
            goto        corrdirect              ;-  .
            D0SLSub     0x01                    ;+
            btfss       STATUS,     C           ; . .
            goto        corrdel4                ;-
            bsf         RUOZFlags,  F_HiDelay   ;  . .
            goto        corrdel1                ;+
corrdel1    goto        corrdel2                ; . .
corrdel2    nop                                 ;-
corrdel3    movf        LoDelay,    W           ;+ .
            movwf       B2                      ;-
            return                              ; <------  .
corrdel4    clrw
            movwf       B0
            movwf       B1
            bcf         RUOZFlags,  F_HiDelay   ;  . .
            goto        corrdel3
corrdirect  bsf         RUOZFlags,  F_AbortDly  ;+
            return                              ;- .


;   Hi2Lo ---------------------------------------------
;     D0  -  , 
;  B2 -  .  D0  B2  .
dodelayh2l  movlw       high precdelay0         ;+               <-------
            movwf       PCLATH                  ;                |
            movf        B2,          W          ; .             |
            sublw       0xFF                    ;                       |
            call        precdelay               ;-                   
            btfss       RUOZFlags,  F_HiDelay   ;+                17 .
            goto        dodlyh2l2               ;   . ?|
            nop                                 ;-                      |
dodlyh2l1   btfsc       PORTB,      RB0         ;+  - |
            goto        dodlyh2l3               ;-  RB0.     |
            call        delay233                ;+                      |
            D0SLSub     0x01                    ;                |
            btfsc       STATUS, C               ; .             |
            goto        dodlyh2l1               ;                       |
            nop                                 ;-                      |
dodlyh2l2   return                                               <-------
dodlyh2l3   bsf         RUOZFlags,  F_AbortDly
            return


;   Lo2Hi ---------------------------------------------
;     D0  -  , 
;  B2 -  .  D0  B2  .
dodelayl2h  movlw       high precdelay0         ;+               <-------
            movwf       PCLATH                  ;                |
            movf        B2,          W          ; .             |
            sublw       0xFF                    ;                       |
            call        precdelay               ;-                   
            btfss       RUOZFlags,  F_HiDelay   ;+                17 .
            goto        dodlyl2h2               ;   . ?|
            nop                                 ;-                      |
dodlyl2h1   btfss       PORTB,      RB0         ;+  - |
            goto        dodlyl2h3               ;-  RB0.      |
            call        delay233                ;+                      |
            D0SLSub     0x01                    ;                |
            btfsc       STATUS, C               ; .             |
            goto        dodlyl2h1               ;                       |
            nop                                 ;-                      |
dodlyl2h2   return                                               <-------
dodlyl2h3   bsf         RUOZFlags,  F_AbortDly
            return


;    hi2low ------------------------------------
hialign     movlw       high precdelay0
            movwf       PCLATH
            movlw       H_Align
            sublw       0xFF
            call        precdelay
            return


;    low2hi ------------------------------------
loalign     movlw       high precdelay0
            movwf       PCLATH
            movlw       L_Align
            sublw       0xFF
            call        precdelay
            return


;    235+21   -----------------------------
;   D0, D1, B7
; : loop   nop                     <+
;                       nop                      |
;                       call        delay233     | 256 
;                       D0SLSub     0x01         | ..D0.. .
;                       btfsc       STATUS, C    |
;                       goto        loop         |
;                       nop                     <+
delay233    movlw       0x0B                    ;+ 
            movwf       B7                      ;-.
dlloop1     call        chktimer                ;  .
            decfsz      B7,         F           ;+  
            goto        dlloop1                 ;-.
            movlw       D'002'                  ;+
            movwf       B7                      ; . .
dlloop2     decfsz      B7,         F           ;
            goto        dlloop2                 ;-
            nop
dlloop3     return


;   -----------------------------------------------
;   chktimer     ,  ,
;    HiTimer.   chktimer0 
; .   W.
chktimer    btfss       INTCON,     T0IF        ;+              <-
            goto        chktimer6               ;                 |
chktimer0   bcf         INTCON,     T0IF        ;                 |
            incf        BlCountLo,  F           ;                 |
            movlw       0x01                    ;        |
            addwf       Timer,      F           ;         |
            btfss       STATUS,     C           ;       |
            goto        chktimer3               ; .        |
            nop                                 ;             17 
            addwf       HiTimer,    F           ;              call
            btfss       HiTimer,    Max_Timer   ;              .
            goto        chktimer1               ;                 |
            bsf         RUOZFlags,  F_TOverflow ;-                |
            return                              ;                 |
chktimer6   goto        chktimer5               ;+                |
chktimer5   goto        chktimer4               ;                 |
chktimer4   goto        chktimer3               ;     |
chktimer3   goto        chktimer2               ; .       |
chktimer2   goto        chktimer1               ;                 |
chktimer1   return                              ;-              <-

;   -----------------------------------------------------------
;       
;     ,   256.
;       D0.    B6  N0,  
; B7 - .     clcdlitr_,  _-1...8.
; clcdltot -      * 256   .
;            
;      -  PC/256.
; Y0  delta   ,   8 , .. 
;  256    .
calcdelay   btfsc       RUOZFlags,  F_TOverflow ;+   
            goto        clcerr                  ;-.
            btfsc       RUOZFlags,  F_HiRotat   ;+ . 
            goto        clcerr0                 ;-.
            btfss       LoTimer,    Rnd_Timer   ;+
            goto        clcdlrnd1               ;   .
            DFSLAdd     CurrTmrHi,  0x01        ;
            goto        clcdlrnd2               ;-
clcdlrnd1   DFSLAdd     CurrTmrHi,  0x00        ; .
clcdlrnd2   movf        D0,         W           ;+
            movwf       CurrTmrHi               ;   
            movf        D0+1,       W           ;  CurrTmr.
            movwf       CurrTmrLo               ;-
            movf        CurrTmrHi,  F           ;  ..
            btfss       STATUS,     Z           ;+ CurrTmrHi |= 0,
            goto        clcdlitr1               ;-   0-I.
            movf        Tbl7,       W           ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo , 
            btfsc       STATUS,     C           ; Tbl7,   II.
            goto        clcdlitr2               ;-
            movf        Tbl6,       W           ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo , 
            btfsc       STATUS,     C           ; Tbl6,   III.
            goto        clcdlitr3               ;-
            movf        Tbl5,       W           ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo , 
            btfsc       STATUS,     C           ; Tbl5,   IV.
            goto        clcdlitr4               ;-
            movf        Tbl4,       W           ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo , 
            btfsc       STATUS,     C           ; Tbl4,   V.
            goto        clcdlitr5               ;-
            movf        Tbl3,       W           ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo , 
            btfsc       STATUS,     C           ; Tbl3,   VI.
            goto        clcdlitr6               ;-
            movf        Tbl2,       W           ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo , 
            btfsc       STATUS,     C           ; Tbl2,   VII.
            goto        clcdlitr7               ;-
            movf        Tbl1,       W           ;+
            subwf       CurrTmrLo,  W           ; CurrTmrLo , 
            btfsc       STATUS,     C           ; Tbl1,   VIII.
            goto        clcdlitr8               ;-
clcdlitr9   movf        Tbl1+1,     W           ;+ IX
            movwf       D0                      ;  
            movf        Tbl1+2,     W           ;  D0.
            movwf       D0+1                    ;-
            movlw       high precdelay0         ;+
            movwf       PCLATH                  ;
            movlw       0xCD                    ; .
            sublw       0xFF                    ;
            call        precdelay               ;-
            goto        clcdltot
clcdlitr8   movf        Tbl2+1,     W           ;+ VIII
            movwf       D0                      ;  
            movf        Tbl2+2,     W           ;  D0.
            movwf       D0+1                    ;-
            movf        Tbl2,       W           ;+
            movwf       B6                      ; N0  B6,
            movf        Tbl2+3,     W           ; delta  B4,
            movwf       B4                      ;  
            movf        Tbl2+4,     W           ; delta  B7.
            movwf       B7                      ;-
            call        calcangl                ;  
            btfss       STATUS,     C           ;+ 
            goto        clcerr                  ;-.
            goto        clcdltot
clcdlitr7   goto        clcdlitr71              ;+.   <------
clcdlitr71  goto        clcdlitr72              ;-                      |
clcdlitr72  movf        Tbl3+1,     W           ;+ VII           |
            movwf       D0                      ;        |
            movf        Tbl3+2,     W           ;  D0.                 |
            movwf       D0+1                    ;-                      
            movf        Tbl3,       W           ;+                  VII
            movwf       B6                      ; N0  B6,
            movf        Tbl3+3,     W           ; delta  B4,           |
            movwf       B4                      ;           |
            movf        Tbl3+4,     W           ; delta  B7.           |
            movwf       B7                      ;-                      |
            call        calcangl                ;        |
            btfss       STATUS,     C           ;+   |
            goto        clcerr                  ;-.            <------
            goto        clcdltot
clcdlitr6   goto        clcdlitr61              ;+                <------
clcdlitr61  goto        clcdlitr62              ; .         |
clcdlitr62  goto        clcdlitr63              ;                       |
clcdlitr63  goto        clcdlitr64              ;-                      |
clcdlitr64  movf        Tbl4+1,     W           ;+ VI            |
            movwf       D0                      ;        |
            movf        Tbl4+2,     W           ;  D0.
            movwf       D0+1                    ;-                  VI
            movf        Tbl4,       W           ;+                      
            movwf       B6                      ; N0  B6,              |
            movf        Tbl4+3,     W           ; delta  B4,           |
            movwf       B4                      ;           |
            movf        Tbl4+4,     W           ; delta  B7.           |
            movwf       B7                      ;-                      |
            call        calcangl                ;        |
            btfss       STATUS,     C           ;+   |
            goto        clcerr                  ;-.            <------
            goto        clcdltot
clcdlitr5   goto        clcdlitr51              ;+                <------
clcdlitr51  goto        clcdlitr52              ;                       |
clcdlitr52  goto        clcdlitr53              ; .         |
clcdlitr53  goto        clcdlitr54              ;                       |
clcdlitr54  goto        clcdlitr55              ;                       |
clcdlitr55  goto        clcdlitr56              ;-                      |
clcdlitr56  movf        Tbl5+1,     W           ;+ V             |
            movwf       D0                      ;        |
            movf        Tbl5+2,     W           ;  D0.
            movwf       D0+1                    ;-                  V
            movf        Tbl5,       W           ;+
            movwf       B6                      ; N0  B6,              |
            movf        Tbl5+3,     W           ; delta  B4,           |
            movwf       B4                      ;           |
            movf        Tbl5+4,     W           ; delta  B7.           |
            movwf       B7                      ;-                      |
            call        calcangl                ;        |
            btfss       STATUS,     C           ;+   |
            goto        clcerr                  ;-.            <------
            goto        clcdltot
clcdlitr4   goto        clcdlitr41              ;+                <------
clcdlitr41  goto        clcdlitr42              ;                       |
clcdlitr42  goto        clcdlitr43              ;                       |
clcdlitr43  goto        clcdlitr44              ; .         |
clcdlitr44  goto        clcdlitr45              ;                       |
clcdlitr45  goto        clcdlitr46              ;                       |
clcdlitr46  goto        clcdlitr47              ;                       |
clcdlitr47  goto        clcdlitr48              ;-                      |
clcdlitr48  movf        Tbl6+1,     W           ;+ IV            |
            movwf       D0                      ;  
            movf        Tbl6+2,     W           ;  D0.             IV
            movwf       D0+1                    ;-
            movf        Tbl6,       W           ;+                      |
            movwf       B6                      ; N0  B6,              |
            movf        Tbl6+3,     W           ; delta  B4,           |
            movwf       B4                      ;           |
            movf        Tbl6+4,     W           ; delta  B7.           |
            movwf       B7                      ;-                      |
            call        calcangl                ;        |
            btfss       STATUS,     C           ;+   |
            goto        clcerr                  ;-.            <------
            goto        clcdltot
clcdlitr3   goto        clcdlitr31              ;+                <------
clcdlitr31  goto        clcdlitr32              ;                       |
clcdlitr32  goto        clcdlitr33              ;                       |
clcdlitr33  goto        clcdlitr34              ;                       |
clcdlitr34  goto        clcdlitr35              ; .         |
clcdlitr35  goto        clcdlitr36              ;                       |
clcdlitr36  goto        clcdlitr37              ;                       |
clcdlitr37  goto        clcdlitr38              ;                       |
clcdlitr38  goto        clcdlitr39              ;                       |
clcdlitr39  goto        clcdlitr310             ;-
clcdlitr310 movf        Tbl7+1,     W           ;+ III       III
            movwf       D0                      ;  
            movf        Tbl7+2,     W           ;  D0.                 |
            movwf       D0+1                    ;-                      |
            movf        Tbl7,       W           ;+                      |
            movwf       B6                      ; N0  B6,              |
            movf        Tbl7+3,     W           ; delta  B4,           |
            movwf       B4                      ;           |
            movf        Tbl7+4,     W           ; delta  B7.           |
            movwf       B7                      ;-                      |
            call        calcangl                ;        |
            btfss       STATUS,     C           ;+   |
            goto        clcerr                  ;-.            <------
            goto        clcdltot
clcdlitr2   goto        clcdlitr21              ;+                <------
clcdlitr21  goto        clcdlitr22              ;                       |
clcdlitr22  goto        clcdlitr23              ;                       |
clcdlitr23  goto        clcdlitr24              ;                       |
clcdlitr24  goto        clcdlitr25              ;                       |
clcdlitr25  goto        clcdlitr26              ; .         |
clcdlitr26  goto        clcdlitr27              ;                       |
clcdlitr27  goto        clcdlitr28              ;                       |
clcdlitr28  goto        clcdlitr29              ;                       |
clcdlitr29  goto        clcdlitr210             ;                       |
clcdlitr210 goto        clcdlitr211             ;
clcdlitr211 goto        clcdlitr212             ;-                  II
clcdlitr212 movf        Tbl8+1,     W           ;+ II
            movwf       D0                      ;        |
            movf        Tbl8+2,     W           ;  D0.                 |
            movwf       D0+1                    ;-                      |
            movf        Tbl8,       W           ;+                      |
            movwf       B6                      ; N0  B6,              |
            movf        Tbl8+3,     W           ; delta  B4,           |
            movwf       B4                      ;           |
            movf        Tbl8+4,     W           ; delta  B7.           |
            movwf       B7                      ;-                      |
            call        calcangl                ;        |
            btfss       STATUS,     C           ;+   |
            goto        clcerr                  ;-.            <------
            goto        clcdltot
clcdlitr1   movf        CurrTmrHi,  W           ;+
            sublw       0x01                    ;    
            btfss       STATUS,     C           ;     .
            goto        clcdlitr0               ;-
            movlw       high precdelay0         ;+                <------
            movwf       PCLATH                  ;                       |
            movlw       0x08                    ; .         |
            sublw       0xFF                    ;                       |
            call        precdelay               ;-                      |
            movf        CurrTmrLo,  W           ;+ CurrTmrLo.   |
            movwf       LoDelay                 ;-                      |
            bsf         STATUS,     C           ;+                      |
            rrf         CurrTmrLo,  F           ;                       |
            movf        Tbl9+1,     W           ;+ I             |
            movwf       D0                      ;        |
            movf        Tbl9+2,     W           ;  D0.
            movwf       D0+1                    ;-                  I
            movf        Tbl9,       W           ;+
            movwf       B6                      ; N0  B6,              |
            movf        Tbl9+3,     W           ; delta  B4,           |
            movwf       B4                      ;           |
            movf        Tbl9+4,     W           ; delta  B7.           |
            movwf       B7                      ;-                      |
            call        calcangl                ;        |
            btfss       STATUS,     C           ;+   |
            goto        clcerr                  ;-.                  |
            movf        LoDelay,    W           ;+ CurrTmrLo.|
            movwf       CurrTmrLo               ;-            <----------
            goto        clcdltot
clcdlitr0   movlw       high precdelay0         ;+
            movwf       PCLATH                  ;
            movlw       0xE5                    ; .
            sublw       0xFF                    ;
            call        precdelay               ;-
            movf        Tbl9+1,     W           ;+ 0
            movwf       D0                      ;  
            movf        Tbl9+2,     W           ;  D0.
            movwf       D0+1                    ;-
clcdltot    movlw       Min_Timer1              ;+  
            movwf       TimerMin                ;-  Min_Timer1.
            call        chktimer
            D0DFAdd     PressAnglHi             ;+
            D0DLSub     P_CorrectH, P_CorrectL  ;-   D0.
            btfss       STATUS,     C           ;+  ,
            goto        clcdltot3               ;-   = 0.
            movf        DlyBoostCnt,F           ;+   
            btfsc       STATUS,     Z           ;  ,  
            goto        clcdltot2               ;- clcdltot2.
            movf        CurrTmrHi,  F           ;+
            btfss       STATUS,     Z           ;
            goto        clcdltot1               ;   ,  
            movlw       Dly_Boo_Tmr             ;    ,
            subwf       CurrTmrLo,  W           ;   .
            btfsc       STATUS,     C           ;
            goto        clcdltot1               ;-
            clrf        DlyBoostCnt             ;+   
            goto        clcdltot2               ;-  .
clcdltot1   decf        DlyBoostCnt             ;+
            D0DLSub     Boo_CorrH,  Boo_CorrL   ;    
            btfss       STATUS,     C           ;    6 .
            goto        clcdltot3               ;-
clcdltot2   movf        D0,         W           ;+
            movwf       TotalAnglHi             ; 
            movf        D0+1,       W           ;  .
            movwf       TotalAnglLo             ;-
            goto        clcdltot4
clcdltot3   clrw                                ;+
            movwf       TotalAnglHi             ;   = 0.
            movwf       TotalAnglLo             ;-
clcdltot4   call        chktimer
            clrw                                ;+
            movwf       D0+1                    ;
            movwf       HiDelay                 ;  Delay.
            movwf       MdDelay                 ;
            movwf       LoDelay                 ;-
            Multiply    TotalAnglHi,CurrTmrHi   ;+<-------  .
            movf        D1,         W           ;
            movwf       HiDelay                 ;  .
            movf        D1+1,       W           ;
            movwf       D0                      ;-
            Multiply    TotalAnglHi,CurrTmrLo   ;+
            call        dadd                    ;
            btfss       STATUS,     C           ;  .
            goto        clcdlcorr1              ;
            incf        HiDelay                 ;-
clcdlcorr1  call        chktimer                ;+
            Multiply    TotalAnglLo,CurrTmrHi   ;
            call        dadd                    ;  .
            btfss       STATUS,     C           ;
            goto        clcdlcorr2              ;
            incf        HiDelay                 ;-
clcdlcorr2  Multiply    TotalAnglLo,CurrTmrLo   ;+
            movf        D1+1,       W           ;
            movwf       B7                      ;
            movf        D1,         W           ;
            movwf       D1+1                    ;
            clrw                                ;  .
            movwf       D1                      ;
            call        dadd                    ;  
            btfss       STATUS,     C           ;
            goto        clcdlcorr3              ;
            incf        HiDelay                 ;-
clcdlcorr3  call        chktimer
            movf        B0,         W           ;+ 
            movwf       MdDelay                 ; . 
            movf        B1,         W           ;+ 
            movwf       LoDelay                 ;-.
            bsf         RUOZFlags,  F_ReadyDly  ; <--------  .
            return
clcerr0     movlw       Min_Timer2              ;+    
            movwf       TimerMin                ;-  Min_Timer2.
            movlw       Hi_RotDel1              ;+
            movwf       MdDelay                 ;    
            movlw       Hi_RotDel2              ; Min_Timer2 -  . .
            movwf       LoDelay                 ;
            clrw                                ;
            movwf       HiDelay                 ;-
clcerr      bcf         RUOZFlags,  F_ReadyDly  ;   .
clcerr1     bcf         RUOZFlags,  F_TOverflow ;   .
            call        chktimer
            return


;    -------------------------------------------
;  D0  Y0,  B6 - N0,  B4 - delta,  B7 -  delta. 
calcangl    movf        CurrTmrLo,  W           ;+ B6  
            subwf       B6,         F           ;-(N0-CurrTmrLo).
            call        bmul                    ;  D1 - (N0-CurrTmrLo)*.delta. 
            movf        B4,         W           ;+ 
            movwf       B7                      ; delta   B7,
            movf        D1,         W           ; .  D1   B4.
            movwf       B4                      ;-
            call        chktimer
            call        bmul                    ;  D1 - (N0-CurrTmrLo)*delta.
            call        dsub                    ;+
            btfss       STATUS,     C           ;
            return                              ;
            clrf        D1                      ;  D0 - *256.
            movf        B4,         W           ;
            movwf       D1+1                    ;
            call        dsub                    ;-
            return


;       -----------------
getpressure btfsc       RUOZFlag2,  F_PSensErr  ;+    
            goto        gtpr2                   ;-  .
gtpr0       movf        CurrADC,    W           ;+ 
            movwf       B4                      ;-   B4.
            call        readadc                 ;   .
            movf        CurrADC,    W           ;    W.
            addwf       B4,         F           ;+ 
            rrf         B4,         F           ;-    B4.
            call        checkadc                ;     .
            call        chktimer                ;  .
            movf        HiPressADC, W           ;+
            subwf       B4,         W           ;
            btfsc       STATUS,     C           ;
            goto        gtpr5                   ;-  IV.
            movf        MdPressADC, W           ;+
            subwf       B4,         W           ;
            btfsc       STATUS,     C           ;
            goto        gtpr4                   ;-  III.
            call        islorotmode             ;+
            btfss       STATUS,     C           ;
            goto        gtpr1                   ;  I  
            movf        MdPressHi,  W           ;   .
            movwf       PressAnglHi             ;
            movf        MdPressLo,  W           ;
            movwf       PressAnglLo             ;
            goto        gtpr6                   ;-
gtpr1       movf        LoPressADC, W           ;+
            subwf       B4,         W           ;
            btfsc       STATUS,     C           ;
            goto        gtpr3                   ;-  II.
gtpr2       movf        LoPressHi,  W           ;+
            movwf       PressAnglHi             ;
            movf        LoPressLo,  W           ;  I.
            movwf       PressAnglLo             ;
            goto        gtpr6                   ;-
gtpr3       movwf       B6                      ;+
            movf        DeltaPrLo,  W           ;  II.
            movwf       B7                      ;  B6 - Delta .
            call        bmul                    ;  7 - Delta  .
            movf        LoPressHi,  W           ;  D1 -  .
            movwf       D0                      ;
            movf        LoPressLo,  W           ; 
            movwf       D0+1                    ;  D0 -  .
            call        dsub                    ;   D0.
            movf        D0,         W           ;
            movwf       PressAnglHi             ;
            movf        D0+1,       W           ;
            movwf       PressAnglLo             ;
            goto        gtpr6                   ;-
gtpr4       movwf       B6                      ;+
            movf        DeltaPrMd,  W           ;  III.
            movwf       B7                      ;  B6 - Delta .
            call        bmul                    ;  7 - Delta  .
            movf        MdPressHi,  W           ;  D1 -  .
            movwf       D0                      ;
            movf        MdPressLo,  W           ; 
            movwf       D0+1                    ;  D0 -  .
            call        dsub                    ;   D0.
            movf        D0,         W           ;
            movwf       PressAnglHi             ;
            movf        D0+1,       W           ;
            movwf       PressAnglLo             ;
            goto        gtpr6                   ;-
gtpr5       movf        HiPressHi,  W           ;+
            movwf       PressAnglHi             ;  IV.
            movf        HiPressLo,  W           ;
            movwf       PressAnglLo             ;-
gtpr6       call        chktimer
            return

            
;     CurrADC ------------------------------------------
readadc     bsf         ADCON0,     GO          ;  AD .
readadc1    btfss       PIR1,       ADIF        ;+  AD?
            goto        readadc1                ;  .
            movf        ADRES,      W           ;+ .
            subwf       CurrADC,    W           ;+ 
            btfss       STATUS,     Z           ;-?
            bcf         RUOZFlag2,  F_PSensCnst ;  .
            movf        ADRES,      W           ;+  .
            movwf       CurrADC                 ;-
            btfss       RUOZFlag2,  F_PSensNChk ;+   ,
            return                              ;-  .
            btfsc       RUOZFlag2,  F_PSensLChk ;   ?
            goto        readadc2                ;  .
            sublw       PSn_MinPres             ;   .
            btfsc       STATUS,     C           ;+  ,
            bsf         RUOZFlag2,  F_PSensLChk ;-  F_PSensLChk.
readadc2    btfsc       RUOZFlag2,  F_PSensHChk ;   ?
            goto        readadc3                ;  .
            movf        CurrADC,    W           ;+  .
            sublw       PSn_MaxPres             ;-
            btfss       STATUS,     C           ;+  ,
            bsf         RUOZFlag2,  F_PSensHChk ;-  F_PSensHChk.
readadc3    comf        RUOZFlag2,  W           ;  !RUOZFlag2.
            andlw       PSChk_Mask              ;  !RUOZFlag2 & PSChk_Mask.
            btfss       STATUS,     Z           ;   Z,    .
            return                              ;    Z.
            bcf         RUOZFlag2,  F_PSensNChk ;   .
            return


;       -------------------------------
;     .     ,  
; ,    .  .  
;      ADC_LimEnd-512.    
; ,    MdPressADC.   ADC_LimEnd-512  .
;      ADCmax=MdPressADC+(128-TMRcur/4),
;  ADCmax=MdPressADC+ADC_LimCnst-TMRcur/4,  ADC_LimCnst = 128; ADC_LimEnd = 208.

checkadc    movf        CurrTmrHi,  W           ;+
            sublw       0x01                    ;    
            btfss       STATUS,     C           ;    MdPressADC.
            goto        checkadc2               ;-
            call        islorotmode             ;+ C = 0,  
            btfss       STATUS,     C           ;   ,
            return                              ;-   .
checkadc1   movf        CurrTmrHi,  W           ;+
            movwf       B6                      ;
            movf        CurrTmrLo,  W           ;  B7 
            movwf       B7                      ; TMRcur/4.
            bcf         STATUS,     C           ;
            rrf         B6,         F           ;
            rrf         B7,         F           ;
            bcf         STATUS,     C           ;
            rrf         B7,         F           ;-
            movf        MdPressADC, W           ;+
            addlw       ADC_LimCnst             ;
            movwf       B6                      ;  B6 
            movf        B7,         W           ; MdPressADC+ADC_LimCnst-TMRcur/4.
            subwf       B6,         F           ;-
            movf        B4,         W           ;+
            movwf       B7                      ; ,  ,
            movf        B6,         W           ;  6  7.
            subwf       B7,         F           ;
            btfss       STATUS,     C           ;-
            return                              ;  .
            movwf       B4                      ;+.
            return                              ;-
checkadc2   movf        MdPressADC, W           ;+   MdPressADC.
            movwf       B4                      ;-
            return


;      .

psdiagout   btfsc       RUOZFlag2,  F_PSensErr  ;+   .
            return                              ;-
            btfsc       RUOZFlag2,  F_PSensCnst ;+   .
            return                              ;-
            btfsc       RUOZFlag2,  F_PSensNChk ;+   .
            goto        psdiagout1              ;-
            bcf         PORTB,      RB5         ;   .
            return                              ;    O'K.
psdiagout1  btfss       BlCountLo,  0x07        ;    128?
            return                              ; .
            clrf        BlCountLo               ;   .
            incf        BlCountHi,  F           ;   .
            btfss       BlCountHi,  0x05        ;     32.
            return                              
            clrf        BlCountHi               ;  .
            btfss       RUOZFlag2,  F_PSensBlOn ;+  
            goto        psdiagblon              ;-( ).
psdiagbloff bcf         PORTB,      RB5         ;   .
            bcf         RUOZFlag2,  F_PSensBlOn ;  .
            return
psdiagblon  bsf         PORTB,      RB5         ;   .
            bsf         RUOZFlag2,  F_PSensBlOn ; .
            return
  

;   n , n   W ------------------------------
; movlw     high precdelay0 <--
; movwf     PCLATH            |   
; movlw     DELAY             |  
; sublw     0xFF            <-- 4 
; call      precdelay       <-- +6=10 .

PRDELAY     CODE        0x6FF
precdelay   addwf       PCL
precdelay0  fill (nop), D'255'
            return

            END 
